#include<iostream>
#include<iomanip>
#include<fstream>
#define INF 1000000
using namespace std;

int n, m, k, d[100], sz[100];
double p[100], psum[101];

double dp[100][101][101];



int main() {
	cin.sync_with_stdio(false);
	
	ifstream in("puusis.txt");
	ofstream out("puuval.txt");
	
	in >> n >> m >> k;
	
	for(int i=0; i<k; i++)
		in >> d[i];
	
	for(int i=0;i<n;i++)
		in >> p[i];
		
	psum[0] = 0;
	
	for(int i=0;i<n;i++)
		psum[i+1] = psum[i] + p[i];
	
	
	sz[0] = m;
	
	for(int i=1;i<100;i++)
		sz[i] = max(1, sz[i-1] - d[(i-1)%k]);
	
	for(int i=0;i<100;i++)
		for(int j=0;j<100;j++)
			for(int k=j+1;k <= 100; k++)
				dp[i][j][k] = INF;
	
	
	
	//Initialize dp array
	
	
	for(int i=0;i<n;i++)
		for(int j=i+1; j <= i+sz[99] && j <= n; j++)
			dp[99][i][j] = (psum[j] - psum[i]) * 100;
	
	
	for(int lev = 98; lev >= 0; lev--)
		for(int i=0;i<n;i++)
			for(int j=i+1;j <= n; j++)
				for(int k=i + sz[lev]; k <= max(j, i+sz[lev]); k++) {
					int rb = min(k, j);
					
					dp[lev][i][j] = min(dp[lev][i][j],
									dp[lev+1][i][k - sz[lev]]  +  dp[lev+1][rb][j]  +  (psum[rb] - psum[k-sz[lev]]) * (lev+1) );
				}
			
	
	
	out << fixed << setprecision(7) << dp[0][0][n] << '\n';
	
	return 0;
	
}































