#include<iostream>
#include<iomanip>
#include<fstream>
using namespace std;


int n, m, k, d[100], sz[100];

double p[100], psum[101];



double recsolve(int l, int r, int lev) {
	
	if(r == l)
		return 0;
	
	//Pick a place for the segment
	
	double ret = 1000000;
	
	for(int i=l; i + sz[lev] <= r|| i == l; i++) {
		int rb = min(r, i + sz[lev]);
		
		ret = min(ret, (psum[rb] - psum[i]) * (lev+1)   +  recsolve(l, i, lev+1)  +  recsolve(rb, r, lev+1) );
	}
	
	return ret;
	
}



int main() {
	cin.sync_with_stdio(false);
	
	ifstream in("puusis.txt");
	ofstream out("puuval.txt");
	
	in >> n >> m >> k;
	
	for(int i=0;i<k;i++)
		in >> d[i];
	
	
	psum[0] = 0;
	
	for(int i=0;i<n;i++) {
		in >> p[i];
		psum[i+1] = psum[i] + p[i];
	}
	
	
	sz[0] = m;
	
	for(int i=0;i<100;i++)
		sz[i+1] = max(1, sz[i] - d[i % k]);
	
	
	
	out << fixed << setprecision(7) << recsolve(0, n, 0) << '\n';
	
	
	return 0;
	
}
